﻿Type=StaticCode
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private start As String
	Private fin As String
	Private su As StringUtilities
	Private bs As String
    Private fore_color As Paint
	Private back_color As Paint
	Private barwidth As Int			
End Sub

 
'Description: Generates EAN8 barcodes
'
'Method of calling:
'Private fx As JFX (this should be declared in Sub Process_Globals of the main module)
'message = "4015675" 
'front_color = fx.Colors.Blue
'back_color = fx.Colors.Yellow
'bar_width = 3
'Private Canvas1 as Canvas
'Canvas1 = EAN8.Draw_EAN8(message, front_color, back_color, bar_width, Canvas1)
'
'where 'message' = message to be encoded - type String
'where 'front_color' = background color of the code - type Paint
'where 'back_color' = foreground color of the code (solid bar color) - type Paint
'where 'bar_width' = the bar width of the front_color (1) and back_color (0) bars - type Int
Public Sub Draw_EAN8 (message As String, fc As Paint, bc As Paint, bw As Int, c As Canvas) As Canvas

  barwidth = bw
  fore_color = fc
  back_color = bc
  Dim flag1, flag2 As Int
  su.Initialize()
 
  flag1 = 0
  flag2 = 0
  If su.stringLength(message) <> 7 Then                'not the right number of digits
'    ToastMessageShow ("You have entered the incorrect number of digits", False) 
    flag2 = 1
  End If  
  
  For i = 1 To su.stringLength(message) 
      If su.Mid(message,i,1) <> "0" And _
	     su.Mid(message,i,1) <> "1" And _
		 su.Mid(message,i,1) <> "2" And _
		 su.Mid(message,i,1) <> "3" And _
		 su.Mid(message,i,1) <> "4" And _
		 su.Mid(message,i,1) <> "5" And _
		 su.Mid(message,i,1) <> "6" And _
		 su.Mid(message,i,1) <> "7" And _
		 su.Mid(message,i,1) <> "8" And _
		 su.Mid(message,i,1) <> "9"  Then
		 flag1 = 1
		 Exit
	  End If	   
	Next 
 
    If flag1 = 1 Then
'   	  ToastMessageShow ("You are attempting to encode non-numeric characters", False)
    End If

   If flag1 = 0 And flag2 = 0 Then                    'calculate and add a checksum for the 8th digit
     Dim z As Double
	 z = 0

    For i = 1 To su.stringLength(message) 
	  If (i) Mod 2 = 1 Then
	    z = z + (su.Val(su.Mid(message,i,1)) * 3)
      Else
	    z = z + (su.Val(su.Mid(message,i,1)) * 1)  
	  End If
	Next  
	
     z = ((Floor(z/10) + 1)*10) - z
	 If z = 0 Or z = 10 Then message = message & "0"
	 If z = 1 Then message = message & "1"
	 If z = 2 Then message = message & "2"
	 If z = 3 Then message = message & "3"
	 If z = 4 Then message = message & "4"
	 If z = 5 Then message = message & "5"
	 If z = 6 Then message = message & "6"
	 If z = 7 Then message = message & "7"
	 If z = 8 Then message = message & "8"
	 If z = 9 Then message = message & "9"


	 build_string(message, c)
   End If
   
   Return c
  
End Sub

Private Sub build_string(message As String, d As Canvas) As Canvas

Dim karak As String
bs = ""
start = "101"	
bs = bs & start
Private ver() As String
'First                 Second  M1     M2     M3      M4    M5
ver = Array As String("Odd", "Odd", "Odd", "Odd" ,"Odd", "Odd", _
                      "Odd", "Odd", "Even", "Odd", "Even", "Even", _
                      "Odd", "Odd", "Even", "Even", "Odd", "Even", _
                      "Odd", "Odd", "Even", "Even", "Even", "Odd", _
                      "Odd", "Even", "Odd", "Odd", "Even", "Even", _
                      "Odd", "Even", "Even", "Odd", "Odd", "Even", _
                      "Odd", "Even", "Even", "Even", "Odd", "Odd", _
                      "Odd", "Even", "Odd", "Even", "Odd", "Even", _
                      "Odd", "Even", "Odd", "Even", "Even", "Odd", _
                      "Odd", "Even", "Even", "Odd", "Even", "Odd")


Private str() As String
                       '  ODD     EVEN       ALL
                       '  LEFT    LEFT      RIGHT
str = Array As String("0001101","0100111","1110010", _
                      "0011001","0110011","1100110", _
                      "0010011","0011011","1101100", _
                      "0111101","0100001","1000010", _
                      "0100011","0011101","1011100", _
                      "0110001","0111001","1001110", _ 
                      "0101111","0000101","1010000", _ 
                      "0111011","0010001","1000100", _ 
                      "0110111","0001001","1001000", _ 
                      "0001011","0010111","1110100") 

Dim first_num, karak_val As Int
first_num = su.Val(su.Mid(message,1,1))


'Log("first_num")
'Log(first_num)
   karak = su.Mid(message,1,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3)

   karak = su.Mid(message,2,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3)
   
   karak = su.Mid(message,3,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3)
   
   karak = su.Mid(message,4,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3)
   
   bs = bs & "01010"

   karak = su.Mid(message,5,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
   karak = su.Mid(message,6,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
   karak = su.Mid(message,7,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
   karak = su.Mid(message,8,1)
   karak_val = su.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
fin = "101"	
bs = bs & fin

draw_barcode_EAN8 (bs, d)
Return d

End Sub

Sub draw_barcode_EAN8 (mes As String, e As Canvas) As Canvas

    Dim cnt As Int = 1
	For i = 1 To su.stringLength(mes) 
	  If su.Mid(mes,i,1) = "1" Then
	    e.DrawRect(cnt,10,barwidth,80,fore_color,True,2)
	  Else
	    e.DrawRect(cnt,10,barwidth,80,back_color,True,2)
	End If  	
	  cnt = cnt + barwidth
	Next  
	
	Return e 


End Sub

